package de.tudresden.inf.st.mquat.solving.clustering;

import de.tudresden.inf.st.mquat.jastadd.model.Resource;

import java.util.HashMap;
import java.util.Map;

public class LinearNormalizer extends AbstractNormalizer implements Normalizer  {

    public LinearNormalizer(Map<String, Double> minValue,  Map<String, Double> maxValue)
    {
        super(minValue, maxValue);
    }

    @Override
    public Map<String, Double> normalize(HardwareComponent hardwareComponent) {
        Map<String, Double> normalizedHWC = new HashMap<>();
        for (String key : hardwareComponent.getValue().keySet()){
            double normalized =
                    (hardwareComponent.getValue().get(key) - minValue.get(key))/(maxValue.get(key) - minValue.get(key));
            normalizedHWC.put(key, normalized);
        }
        return normalizedHWC;
    }
}
